# TODO:
# - fix CC detection in configure, so CC=gcc won't be needed
Summary:	An open-source memory debugger
Summary(pl.UTF-8):	Otwarty odpluskwiacz pamięci
Name:		valgrind
Version:	3.9.0
Release:	1
License:	GPL
Group:		Development/Tools
Source0:	http://valgrind.org/downloads/%{name}-%{version}.tar.bz2
# Source0-md5:	0947de8112f946b9ce64764af7be6df2
Patch0:		%{name}-native-cpuid.patch
Patch1:		%{name}-ld_linux_strlen.patch
URL:		http://valgrind.org/
BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	gcc >= 5:3.0
BuildRequires:	glibc-devel >= 6:2.2
BuildRequires:	glibc-devel < 6:2.19
BuildRequires:	libgomp-devel
BuildRequires:	libstdc++-devel
Obsoletes:	valgrind-callgrind
Obsoletes:	valgrind-calltree
ExclusiveArch:	%{ix86} %{x8664} arm ppc ppc64 s390x
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_noautostrip	.*/vgpreload.*\\.so
# ld portion broken
%undefine	with_ccache

%description
Valgrind is a GPL'd system for debugging and profiling Linux programs.
With the tools that come with Valgrind, you can automatically detect
many memory management and threading bugs, avoiding hours of
frustrating bug-hunting, making your programs more stable. You can
also perform detailed profiling to help speed up your programs.

%description -l pl.UTF-8
Valgrind jest systemem służącym do odpluskwiania i profilowania
programów na Linuksie. Używając dostarczanych z nim narzędzi można
automatycznie wykrywać wiele błędów związanych z zarządzaniem pamięcią
i wątkowaniem, dzięki czemu unika się frustrującego polowania na
błędy, a także czyni się programy bardziej stabilnymi. Możliwe jest
również dokładne profilowanie, dzięki któremu programy zaczną szybciej
pracować.

%prep
%setup -q
%patch0 -p1
%patch1 -p1

sed -i -e 's:^CFLAGS="-Wno-long-long":CFLAGS="$CFLAGS -Wno-long-long":' configure.ac

%build
%{__aclocal}
%{__autoheader}
%{__autoconf}
%{__automake}

ac_cv_path_GDB=/usr/bin/gdb \
%configure \
	CC=gcc \
	--enable-tls \
%if %{_lib} != "lib"
	--enable-only64bit \
%endif
	LDFLAGS="" # no strip!

%{__make}

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

%{__rm} -r $RPM_BUILD_ROOT%{_datadir}/doc
cp -p docs/index.pdf docs/valgrind_manual.pdf
cp -p docs/index.ps docs/valgrind_manual.ps

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc AUTHORS NEWS README README_MISSING_SYSCALL_OR_IOCTL
%doc docs/html docs/valgrind_manual.pdf docs/valgrind_manual.ps
%attr(755,root,root) %{_bindir}/callgrind_annotate
%attr(755,root,root) %{_bindir}/callgrind_control
%attr(755,root,root) %{_bindir}/cg_annotate
%attr(755,root,root) %{_bindir}/cg_diff
%attr(755,root,root) %{_bindir}/cg_merge
%attr(755,root,root) %{_bindir}/ms_print
%attr(755,root,root) %{_bindir}/valgrind
%attr(755,root,root) %{_bindir}/valgrind-di-server
%attr(755,root,root) %{_bindir}/valgrind-listener
%attr(755,root,root) %{_bindir}/vgdb
%dir %{_libdir}/%{name}
%attr(755,root,root) %{_libdir}/%{name}/*-linux
%attr(755,root,root) %{_libdir}/%{name}/vgpreload_*-linux.so
%{_libdir}/%{name}/*.xml
%{_libdir}/%{name}/default.supp
%{_libdir}/%{name}/lib*-linux.a
%{_includedir}/valgrind
%{_mandir}/man1/callgrind_annotate.1*
%{_mandir}/man1/callgrind_control.1*
%{_mandir}/man1/cg_annotate.1*
%{_mandir}/man1/cg_diff.1*
%{_mandir}/man1/cg_merge.1*
%{_mandir}/man1/ms_print.1*
%{_mandir}/man1/valgrind.1*
%{_mandir}/man1/valgrind-listener.1*
%{_mandir}/man1/vgdb.1*
%{_pkgconfigdir}/valgrind.pc
%changelog
* Sat Nov 30 2013 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/valgrind.git;a=log;h=master

* Sun Nov 03 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> ef1230c
- up to 3.9.0

* Sun Oct 21 2012 Jan Rękorajski <baggins@pld-linux.org> 660a560
- rebuild to fix broken filedigests
- release 3 (by relup.sh)

* Mon Sep 24 2012 Jan Rękorajski <baggins@pld-linux.org> 0706b7f
- rebuild with fixed rpm macros
- release 2 (by relup.sh)

* Sat Sep 22 2012 Paweł Sikora <pawel.sikora@agmk.net> 9cf103c
- updated to 3.8.1.

* Thu Aug 23 2012 Paweł Sikora <pawel.sikora@agmk.net> 26efc40
- works fine, so release 1.

* Tue Aug 21 2012 Kacper Kornet <draenog@pld-linux.org> 5beaf08
- Up to 3.8.0

* Sat Jul 21 2012 Paweł Sikora <pawel.sikora@agmk.net> 7986a36
- fix build with glibc-2.16, patch signed-off-by Khem Raj.

* Sat Feb 11 2012 Arkadiusz Miśkiewicz <arekm@maven.pl> f0ea88b
- rel 4; glibc 2.15 support

* Mon Jan 23 2012 Arkadiusz Miśkiewicz <arekm@maven.pl> 4ed0a07
- release 3

* Mon Jan 23 2012 Jacek Konieczny <jajcus@pld-linux.org> 24db299
- Valgrind insisted on redirecting the 'strlen' symbol in /lib/ld-linux.so.2,
  but it seem the symbol is not there on i686 PLD.
  valgrind-ld_linux_strlen.patch makes this redirection optional.

* Mon Jan 23 2012 Jacek Konieczny <jajcus@pld-linux.org> 3a93a74
- automake 1.11.2 compatibility patch
- more specific glibc dependency
- Release: 2

* Sun Dec 11 2011 Jakub Bogusz <qboosh@pld-linux.org> 54375cc
- more verbose files
- requires gcc 3.0+ and C++ compiler
- supports also ARM and s390x

* Sat Dec 10 2011 Arkadiusz Miśkiewicz <arekm@maven.pl> 23a3ecd
- up to 3.7.0

* Fri Aug 05 2011 Karol Krenski <charles@pld-linux.org> 67eca5c
- implement DWARF comparison and shift operators; fixed:
  Warning: DWARF2 CFI reader: unhandled DW_OP_ opcode 0x2a
  m_debuginfo/readdwarf.c:2338 (copy_convert_CfiExpr_tree): Assertion 'srcix >= 0 && srcix < VG_(sizeXA)(srcxa)' failed.

* Fri Aug 05 2011 Karol Krenski <charles@pld-linux.org> 1ef71e0
- fixed build with glibc 2.14

* Fri Aug 05 2011 Karol Krenski <charles@pld-linux.org> 3d3b641
- added -opge.patch (implement DWARF comparison and shift operators)
- added -glibc214.patch (fix build)
- rel. 2

* Thu Mar 03 2011 Jan Palus <jan.palus@gmail.com> d01a7b3
- obsolete

* Thu Mar 03 2011 Jan Palus <jan.palus@gmail.com> 6a71ccd
- up to 3.6.1

* Mon Jan 17 2011 Paweł Sikora <pluto@pld-linux.org> e5bb550
- add unofficial support for --vex-native-cpuid=yes|no.
  with this option users can test dynamically selected code
  without over-emulated valgrind's cpu.

* Mon Jan 17 2011 Paweł Sikora <pluto@pld-linux.org> 1dc3004
- fix: vex amd64->IR: unhandled instruction bytes: 0x66 0xF 0x3A 0x61 0x7 0x0
       https://bugs.kde.org/show_bug.cgi?id=262995
- release 3.

